#include "stdafx.h"
#include "Ts1segFilter.h"
#include "TsPatPacket.h"
#include "TsPmtPacket.h"

CTs1segFilter::CTs1segFilter(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1, 1), m_bUpdatePat( TRUE )
{
	this->Reset();
#if USE_STATICPASS
//	this->m_wStaticPassTable.insert( 0x0000 );	// PAT(ZOł͕sv)
//	this->m_wStaticPassTable.insert( 0x0001 );	// CAT
	this->m_wStaticPassTable.insert( 0x0010 );	// NIT
	this->m_wStaticPassTable.insert( 0x0011 );	// SDT/BAT
	this->m_wStaticPassTable.insert( 0x0012 );	// EIT
	this->m_wStaticPassTable.insert( 0x0026 );	// EIT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0027 );	// EIT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0013 );	// RST
	this->m_wStaticPassTable.insert( 0x0014 );	// TDT/TOT
	this->m_wStaticPassTable.insert( 0x0017 );	// DCT
	this->m_wStaticPassTable.insert( 0x001E );	// DIT
	this->m_wStaticPassTable.insert( 0x001F );	// SIT
	this->m_wStaticPassTable.insert( 0x0020 );	// LIT
	this->m_wStaticPassTable.insert( 0x0021 );	// ERT
	this->m_wStaticPassTable.insert( 0x0022 );	// PCAT
	this->m_wStaticPassTable.insert( 0x0023 );	// SDTT
	this->m_wStaticPassTable.insert( 0x0028 );	// SDTT(nfW^erW)
	this->m_wStaticPassTable.insert( 0x0024 );	// BIT
	this->m_wStaticPassTable.insert( 0x0025 );	// NBIT
	this->m_wStaticPassTable.insert( 0x0025 );	// LDT
	this->m_wStaticPassTable.insert( 0x0029 );	// CDT
	this->m_wStaticPassTable.insert( 0x002F );	// dt[wb_
//	this->m_wStaticPassTable.insert( 0x1FFF );	// kpPbg
#endif
}

CTs1segFilter::~CTs1segFilter()
{
}

const bool CTs1segFilter::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	CBlockLock Lock( &this->m_DecoderLock );

	CTsPacket* t_pcTsPacket = static_cast< CTsPacket* >( pMediaData );
	WORD t_wPid = t_pcTsPacket->GetPID();

	if( 0x1fc8 == t_wPid )	// ZOPMTT(dꂽԑgɂ͑ΉĂȂ)
//	if( ( 0x1fc8 <= t_wPid ) && ( t_wPid <= 0x1fcf ) )	// ZOPMTT
	{
		this->PmtProcessor( t_pcTsPacket );
	}
	else if( this->m_bUpdatePat && ( t_wPid == 0x0000 ) )	// PATT
	{
		this->PatProcessor( t_pcTsPacket );
	}

	// PMTɋLꂽPIDƁAɕKvȌŒPID𓧉߂
	if( ( this->m_wDynamicPassTable.find( t_wPid ) != this->m_wDynamicPassTable.end() )
#if USE_STATICPASS
	 || ( this->m_wStaticPassTable.find( t_wPid ) != this->m_wStaticPassTable.end() )
#else
	 || ( 0x0000 == t_wPid )								// PAT͒ʉ߂
	 || ( ( 0x0010 <= t_wPid ) && ( t_wPid <= 0x0030 ) )	// ŒPID́A͈͂œĂĂ܂
#endif
	)
	{
		return this->OutputMedia( t_pcTsPacket, dwInputIndex );
	}

	return true;
}

void CTs1segFilter::Reset()
{
	CBlockLock Lock( &this->m_DecoderLock );

	this->m_wDynamicPassTable.clear();
}

void CTs1segFilter::SetUpdatePat( BOOL t_bUpdatePat )
{
	this->m_bUpdatePat = t_bUpdatePat;
}

void CTs1segFilter::PatProcessor( CTsPacket* t_pcTsPacket )
{
	// PATZÔ݂ɏ
	CTsPatPacket t_cTsPatPacket;

	t_cTsPatPacket.StorePacket( t_pcTsPacket );

	// lbg[NPID/ZOPMT̂ݎc
	for( INT32 t_nIndex = static_cast< INT32 >( t_cTsPatPacket.GetPmtPidSize() ) ; t_nIndex-- ;  )
	{
		CTsPatPacket::STPmt& tr_stPmt = t_cTsPatPacket.GetPmtPid( t_nIndex );

		if( ( tr_stPmt.m_wPmt == 0x0010 ) || ( ( 0x1fc8 <= tr_stPmt.m_wPmt ) && ( tr_stPmt.m_wPmt <= 0x1fcf ) ) )
		{
		}
		else
		{
			// 폜
			t_cTsPatPacket.RemovePmtPid( t_nIndex );
		}
	}
	
	// PMT̓e
	t_cTsPatPacket.UpdatePacket( t_pcTsPacket );
}

void CTs1segFilter::PmtProcessor( CTsPacket* t_pcTsPacket )
{
	// ʉ߂PMTXgAbv
	this->m_wDynamicPassTable.clear();

	CTsPmtPacket t_cTsPmtPacket;

	t_cTsPmtPacket.StorePacket( t_pcTsPacket );
	
	INT32 t_nSize = static_cast< INT32 >( t_cTsPmtPacket.GetEsPidSize() );

	/*
	// PMT̍XV()
	case STREAM_TYPE_MPEG2:
	case STREAM_TYPE_CAPTION:
	case STREAM_TYPE_DATACARROUSEL:
	case STREAM_TYPE_AAC:
	case STREAM_TYPE_H264:
	*/

	// ʉ߂PIDXgAbv
	for( INT32 t_nIndex = 0 ; t_nIndex < t_nSize ; t_nIndex++ )
	{
		CTsPmtPacket::STPid& tr_stPid = t_cTsPmtPacket.GetEsPid( t_nIndex );
		this->m_wDynamicPassTable.insert( tr_stPid.m_wPid );
	}

	this->m_wDynamicPassTable.insert( t_cTsPmtPacket.GetPmtPid() );
	this->m_wDynamicPassTable.insert( t_cTsPmtPacket.GetPcrPid() );
}
