// BonTuner.h: CBonTuner NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "BonTsEngine\IBonDriver2.h"
#include "BonTsEngine\BonSrcDecoder1seg.h"
#include "BonTsEngine\TsPacketParser.h"
#include "BonTsEngine\Ts1segFilter.h"
#include "BonTsEngine\TsBuffer.h"
#include <string>

class CBonTuner : public IBonDriver2
{
public:
	CBonTuner();
	virtual ~CBonTuner();

// IBonDriver
	const BOOL OpenTuner(void);
	void CloseTuner(void);

	const BOOL SetChannel(const BYTE bCh);
	const float GetSignalLevel(void);

	const DWORD WaitTsStream(const DWORD dwTimeOut = 0);
	const DWORD GetReadyCount(void);

	const BOOL GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain);
	const BOOL GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain);

	void PurgeTsStream(void);

// IBonDriver2(b)
	LPCTSTR GetTunerName(void);

	const BOOL IsTunerOpening(void);
	
	LPCTSTR EnumTuningSpace(const DWORD dwSpace);
	LPCTSTR EnumChannelName(const DWORD dwSpace, const DWORD dwChannel);

	const BOOL SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	
	const DWORD GetCurSpace(void);
	const DWORD GetCurChannel(void);

	void Release(void);

	static CBonTuner* ms_pcThis;
	static HINSTANCE ms_hModule;

protected:
	HMODULE m_hBonDriverDll;
	IBonDriver* m_piBonDriver;
	std::wstring m_strTunerName;
	CBonSrcDecoder1seg m_cSrcDecoder;
	CTsPacketParser m_cTsPacketParser;
	CTs1segFilter m_cTs1segFilter;
	CTsBuffer m_cTsBuffer;

	BOOL m_bRelease;
};
